/**
 * ##% Copyright (C) 2008 Code Lutin, Tony Chemit
 * This program is free software; you
 * can redistribute it and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. This program is
 * distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details. You
 * should have received a copy of the GNU General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 59 Temple Place
 * - Suite 330, Boston, MA 02111-1307, USA. 
 * ##%
 */
package org.nuiton.jaxx.action;

import static org.nuiton.i18n.I18n._;

import javax.swing.Action;
import javax.swing.JComboBox;

/**
 * Implementation of configuration's resolver for annotation {@link SelectActionConfig}
 *
 * @author chemit
 */
public class SelectActionConfigConfigurationResolver extends AbstractActionConfigurationResolver<SelectActionConfig, JComboBox> {

    public SelectActionConfigConfigurationResolver() {
        super(SelectActionConfig.class, JComboBox.class);
    }

    @Override
    protected SelectActionConfig applyConfiguration0(JComboBox component, MyAbstractAction action) {
        SelectActionConfig anno = resolveConfiguration(action);
        if (anno == null) {
            return null;
        }
        // inject les données
        if (!anno.name().isEmpty()) {
            action.putValue(Action.NAME, _(anno.name()));
        }
        if (!anno.shortDescription().isEmpty()) {
            action.putValue(Action.SHORT_DESCRIPTION, _(anno.shortDescription()));
        } else {
            action.putValue(Action.SHORT_DESCRIPTION, _(component.getToolTipText()));
        }
        action.putValue("selectedIndex", anno.selectedIndex());
        //TODO Convert it from String action.putValue(Action.ACCELERATOR_KEY, anno.accelerator());
        action.setEnabled(anno.enabled());

        return anno;
    }
}